<?php

/*
$wmi = new Linux_WMI ();
$wmi->hostname = '192.168.126.1';
$wmi->username = 'test';
$wmi->password = 'test';
$wmi->command = "select * from Win32_Process";

$results = $wmi->fetch();
print_r($results);
*/

class Linux_WMI {
	var $hostid;		// ID of host, to pull authenication from
	var $hostname;	// Hostname / IP to contact
	var $username;	// Username to authenicate with (will be pulled from DB)
	var $password;	// Password to authenicate with (will be pulled form DB)
	var $command;		// This is the WMI Query to exec
	var $results;		// This will hold all our data
	var $binary;		// Path to WMIC binary
	var $separator;	// Separator (defaults to |)
	var $error;		// Last Error message
	var $indexkey;	// Key to use as Index
	var $keys;		// Comma separated keys
	var $queryclass;	// Class name to pull

	function Linux_WMI($hostid = '') {
		// Function for initial create
		$this->binary = './wmic';
		$this->separator = '|';
		$this->error = '';
		if ($hostid != '') {
			$this->hostid = $hostid;

			/* Ensure we have a username / password pair setup for this host */
			$this->retrieve_account();
		}
	}

	function create_query() {
		$this->command = "SELECT ";
		if ($this->keys != '') {
			if ($this->indexkey != '') {
				$this->command .= $this->indexkey . ',';
			}
			$this->command .= $this->keys;
		} else	if ($this->indexkey != '') {
				$this->command .= $this->indexkey . ',';
		} else {
			$this->command = '';
			$this->error = 'WMI Keys and Index is Empty!';
			return;
		}
		$this->command .= ' FROM ';
		if ($this->queryclass != '') {
			$this->command .= $this->queryclass;
		} else {
			$this->command = '';
			$this->error = 'WMI Query Class is empty!';
			return;
		}
	}

	function fetch_key_index ($name) {
		if (isset($this->results[1])) {
			foreach ($this->results[1] as $i => $a) {
				if ($a == $name) {
					return $i;
				}
			}
			$this->error = 'Key not found';
			return '';
		}
		$this->error = 'Empty Result!';
		return '';
	}

	function fetch_value($keyname, $index) {
		$i = $this->fetch_key_index($this->indexkey);
		$k = $this->fetch_key_index($keyname);
		$results = $this->results;
		if (isset($results[2])) {
			array_shift($results);
			array_shift($results);
			foreach ($results as $r) {
				if (str_replace(array(' ','(', ')'), '', $r[$i]) == $index) {
					return $r[$k];
				}
			}
		}
		return '';
	}

	function print_fetch_key_value_pair ($keyname, $index) {
		$i = $this->fetch_key_index($this->indexkey);
		$k = $this->fetch_key_index($keyname);
		$results = $this->results;
		if (isset($results[2])) {
			array_shift($results);
			array_shift($results);
			foreach ($results as $r) {
				if (str_replace(array(' ','(', ')'), '', $r[$i]) == $index) {
					print "$keyname!" . $r[$k] . "'\n";
				}
			}
		}
	}

	function print_indexes () {
		$k = $this->fetch_key_index($this->indexkey);
		$results = $this->results;
		if (isset($results[2])) {
			array_shift($results);
			array_shift($results);
			foreach ($results as $r) {
				/* Indexes should not have spaces in their name so we remove them */
				print str_replace(array(' ','(', ')'), '', $r[$k]) . '!' . str_replace(array(' ','(', ')'), '', $r[$k]) . "\n";
			}
		}
	}

	function fetch () {
		if ($this->command == '') {
			$this->error = 'WMI Query is empty';
			return;
		}
		$results = $this->exec();
		$results = explode("\n", trim($results));
		foreach ($results as $id => $result) {
				$results[$id] = explode($this->separator, $result);
		}
		$this->results = $results;
		return $results;
	}

	function exec () {
		$this->clean();
		if ($this->username == '' || $this->password == '') {
			$this->error = 'Username or Password not set!';
			return;
		}
		$command = $this->binary . ' -U ' . $this->username . '%' . $this->password . ' //' . $this->hostname . ' "' . $this->command . '"';
		$config['cacti_server_os'] = 'unix';
		if (function_exists('popen')) {
			if ($config['cacti_server_os'] == 'unix') {
				$fp = @popen($command, 'r');
			}else{
				$fp = @popen($command, 'rb');
			}
			/* return if the popen command was not successfull */
			if ($fp == 0) {
				return '';
			}
			$output = '';
			while (!feof($fp)) {
				$output .= @fgets($fp, 4096);
			}
			@pclose($fp);
		} else {
			$output = `$command`;
		}
		return $output;
	}

	function clean () {
		$this->username = str_replace(array('&', '>', '<', '|', '"'), '', $this->username);
		$this->password = str_replace(array('&', '>', '<', '|', '"'), '', $this->password);
		$this->hostname = str_replace(array('&', '>', '<', '|', '"'), '', $this->hostname);
		$this->binary   = str_replace(array('&', '>', '<', '|', '"'), '', $this->binary);
	}

	function retrieve_account () {
		if ($this->hostid == '') {
			$this->error = 'Hostid is not set!';
			return false;
		}
		$info = db_fetch_row("SELECT plugin_wmi_accounts.* FROM plugin_wmi_accounts,host WHERE plugin_wmi_accounts.id = host.wmi_account AND host.id = " . $this->hostid, FALSE);
		if (isset($info['username'])) {
			$this->username = $info['username'];
			$this->password = $this->decode($info['password']);
			return true;
		}
		$this->error = 'WMI Authenication account not found!';
		return false;		
	}

	function decode ($info) {
		$info = base64_decode($info);
		$info = unserialize($info);
		$info = $info['password'];
		return $info;
	}

	function encode ($info) {
		$a = array(rand(1,time()) => rand(1,time()),'password' => '', rand(1,time()) => rand(1,time()));
		$a['password'] = $info;
		$a = serialize($a);
		$a = base64_encode($a);
		return $a;
	}

}