<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/

function plugin_init_wmi() {
	global $plugin_hooks;
	$plugin_hooks['config_arrays']['wmi'] = 'wmi_config_arrays';
	$plugin_hooks['config_form']['wmi'] = 'wmi_config_form';
	$plugin_hooks['api_device_save']['wmi'] = 'wmi_api_device_save';
	$plugin_hooks['draw_navigation_text']['wmi'] = 'wmi_draw_navigation_text';
}

function wmi_version () {
	return array( 'name' 	=> 'wmi',
			'version' 	=> '0.1',
			'longname'	=> 'WMI Query',
			'author'	=> 'Jimmy Conner',
			'homepage'	=> 'http://cactiusers.org',
			'email'	=> 'jimmy@sqmail.org',
			'url'		=> 'http://cactiusers.org/cacti/versions.php'
			);
}

function wmi_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu;

//	$user_auth_realm_filenames['wmi-tools.php'] = 8;
	$user_auth_realm_filenames['wmi-accounts.php'] = 8;
	$user_auth_realm_filenames['wmi-queries.php'] = 8;

//	$temp = $menu["Utilities"]['logout.php'];
//	unset($menu["Utilities"]['logout.php']);
//	$menu["Utilities"]['plugins/wmi/wmi-tools.php'] = "WMI Query";
//	$menu["Utilities"]['logout.php'] = $temp;
	$menu["Configuration"]['plugins/wmi/wmi-accounts.php'] = "WMI Settings";


}
function wmi_draw_navigation_text ($nav) {
	$nav["wmi-accounts.php:"] = array("title" => "WMI Autenication", "mapping" => "index.php:", "url" => "wmi-accounts.php", "level" => "1");
	$nav["wmi-accounts.php:edit"] = array("title" => "WMI Autenication -> Edit", "mapping" => "index.php:", "url" => "wmi-accounts.php", "level" => "1");
	$nav["wmi-accounts.php:actions"] = array("title" => "WMI Autenication", "mapping" => "index.php:", "url" => "wmi-accounts.php", "level" => "1");
	$nav["wmi-queries.php:"] = array("title" => "WMI Query", "mapping" => "index.php:", "url" => "wmi-queries.php", "level" => "1");
	$nav["wmi-queries.php:edit"] = array("title" => "WMI Query -> Edit", "mapping" => "index.php:", "url" => "wmi-queries.php", "level" => "2");
	$nav["wmi-queries.php:actions"] = array("title" => "WMI Query", "mapping" => "index.php:", "url" => "wmi-queries.php", "level" => "2");

//	$nav["wmi-tools.php:"] = array("title" => "WMI Query", "mapping" => "index.php:", "url" => "wmi-tools.php", "level" => "1");
//	$nav["wmi-tools.php:query"] = array("title" => "WMI Query", "mapping" => "index.php:", "url" => "wmi-tools.php", "level" => "1");
	return $nav;
}

function wmi_config_form () {
	global $fields_host_edit, $plugins;

//	$fields_host_edit2 = $fields_host_edit;
//	$fields_host_edit3 = array();
//	foreach ($fields_host_edit2 as $f => $a) {
//		if ($f == 'disabled') {
//			$fields_host_edit3['serial'] = array(
//				'friendly_name' => 'Serial / Service Code',
//				'description' => 'This is the Serial Number for this server.',
//				'method' => 'textbox',
//				'max_length' => 100,
//				'value' => '|arg1:serial|',
//				'default' => '',
//			);
//		} 
//		$fields_host_edit3[$f] = $a;
//	}
//	$fields_host_edit = $fields_host_edit3;

	$acc = array('None');
	$accounts = db_fetch_assoc("SELECT id, name FROM plugin_wmi_accounts ORDER BY name", false);
	if (!empty($accounts)) {
		foreach ($accounts as $a) {
			$acc[$a['id']] = $a['name'];
		}
	}

	$fields_host_edit["wmi_spacer"] = array(
		"method" => "spacer",
		"friendly_name" => "WMI Account Options"
		);
	$fields_host_edit["wmi_account"] = array(
		"method" => "drop_array",
		"friendly_name" => "WMI Authenication Account",
		"description" => "Choose an account to use when Authenticating via WMI",
		"value" => "|arg1:wmi_account|",
		"default" => 0,
		"array" => $acc,
		);
}

function wmi_api_device_save ($save) {
//	if (isset($_POST['serial']))
//		$save['serial'] = form_input_validate($_POST['serial'], 'serial', '', true, 3);
//	else
//		$save['serial'] = form_input_validate('', 'serial', '', true, 3);

	if (isset($_POST['wmi_account']))
		$save['wmi_account'] = form_input_validate($_POST['wmi_account'], 'wmi_account', "^[0-9]+$", false, 3);
	else
		$save['wmi_account'] = 0;
	return $save;
}